Imports NEROLib
'clsBrennen: Beinhaltet die Funktionen zum Brennen und lschen
Public Class clsBrennen

#Region "Events, Enums, Variablen"
    'CdGelscht, CdGebrannt, Prozenangabe, NeueLogZeile, SchwererFehler, VorgangAktivnderung
#Region "Events"
    Friend Event CdGelscht(ByVal Erfolg As Boolean, ByVal Info As String, ByVal InfoTyp As eInfoTyp)
    Friend Event CdGebrannt(ByVal Info As String, ByVal InfoTyp As eInfoTyp, ByVal Erfolg As Boolean)
    Friend Event Prozenangabe(ByVal Prozent As Integer)
    Friend Event NeueLogZeile(ByVal Info As String, ByVal infotyp As eInfoTyp)
    Friend Event SchwererFehler()
    Friend Event VorgangAktivnderung(ByVal Aktiv As Boolean)
#End Region


    'eInfoTyp, eVorgang, eErneutesBrennen
#Region "Enums"
    'Fr Log-Liste. Beinhaltet ImageList-Indexe fr Info, Kritisch, Fehler und Frage-Symbole
    Friend Enum eInfoTyp
        Info = 0
        Kritisch = 1
        Fehler = 2
        Frage = 3
    End Enum

    'Wird in OnDoneCdInfo bentigt und zeigt den nchsten Schritt an
    Private Enum eVorgang
        Brennen
        Lschen
        Keiner
    End Enum

    'Wird bentigt, wenn Brennen nach Fehler oder voller CDRW erneut versucht wird
    Private Enum eErneutesBrennen
        Fertig
        SollLschen
        SollBrennen
        IstAktiv
    End Enum
#End Region


    'AktuellesLaufwerk, Nero, DurchzufhrenderVorgang, WarteKlasse, ErneutesBrennen, SollAbbrechen, Settings
#Region "Variablen"
    Private WithEvents AktuellesLaufwerk As NeroDrive 'Das aktuell ausgewhlte Laufwerk
    Private WithEvents Nero As New Nero
    Private DurchzufhrenderVorgang As eVorgang = eVorgang.Keiner 'Vor Brennen oder lschen muss auf das OnDoneCdInfo-Event gewartet werden.
    '                                                              Von dort aus wird Brennen oder Lschen gestartet. Die Variable speichert, was zu tun ist
    Private WithEvents WarteKlasse As New clsWarte
    Private ErneutesBrennen As eErneutesBrennen = eErneutesBrennen.Fertig 'Erneutes Brennen wird benutzt, wenn vor dem Brennen ein voller 
    '                                                                      CdRw drin liegt, der erst gelscht und dann erneut gebrannt werden muss
    Private SollAbbrechen As Boolean
    Private Settings As clsSettings 'Einstellungen, nach deren Vorgaben gebrannt wird
#End Region
#End Region


    'New
#Region "Initialisierung"
    'Einstellungen werden der Klasse bergeben, so ist sie nicht an dieses Projekt gebunden
    Friend Sub New(ByVal pSettings As clsSettings)
        Settings = pSettings
    End Sub
#End Region

    'AktuellesLaufwerk_OnDoneErase, AktuellesLaufwerk_OnProgress,
    'AktuellesLaufwerk_OnDoneBurn, AktuellesLaufwerk_OnAddLogLine, AktuellesLaufwerk_OnSetPhase,
    'Nero_OnMegaFatal, AktuellesLaufwerk_OnDoneCDInfo, Nero_OnWaitCD
#Region "Nero-Events"
    'Rohling erfolgreich gelscht. Falls Lschen Vorbereitung zum Brennen war, wird anschlieend gebrannt
    Private Sub AktuellesLaufwerk_OnDoneErase(ByRef Ok As Boolean) Handles AktuellesLaufwerk.OnDoneErase
        If Ok Then
            RaiseEvent CdGelscht(True, "CD RW erfolgreich gelscht", eInfoTyp.Info)
            If ErneutesBrennen = eErneutesBrennen.IstAktiv Then
                ErneutesBrennen = eErneutesBrennen.SollBrennen
                WarteKlasse.Warte(3000)
            Else
                RaiseEvent VorgangAktivnderung(False)
                DurchzufhrenderVorgang = eVorgang.Keiner
            End If
        End If
    End Sub

    'Zeigt den Prozentualen Fortschritt an
    Private Sub AktuellesLaufwerk_OnProgress(ByRef ProgressInPercent As Integer, ByRef Abort As Boolean) Handles AktuellesLaufwerk.OnProgress
        RaiseEvent Prozenangabe(ProgressInPercent)
    End Sub

    'Gibt Information ber abgeschlossenen Brennvorgang in die Log-Liste aus
    Private Sub AktuellesLaufwerk_OnDoneBurn(ByRef StatusCode As NEROLib.NERO_BURN_ERROR) Handles AktuellesLaufwerk.OnDoneBurn
        Dim infotyp As eInfoTyp
        Dim Text As String
        Select Case StatusCode
            Case NERO_BURN_ERROR.NERO_BURN_OK
                infotyp = eInfoTyp.Info
                Text = "Brennen erfolgreich beendet"
            Case NERO_BURN_ERROR.NERO_BURN_FAILED
                infotyp = eInfoTyp.Fehler
                Text = "Brennen fehlgeschlagen"
            Case NERO_BURN_ERROR.NERO_BURN_USER_ABORT
                infotyp = eInfoTyp.Kritisch
                Text = "Brennvorgang abgebrochen"
            Case NERO_BURN_ERROR.NERO_BURN_DRIVE_NOT_ALLOWED
                infotyp = eInfoTyp.Fehler
                Text = "Das Laufwerk ist nicht bereit"
            Case NERO_BURN_ERROR.NERO_BURN_FUNCTION_NOT_ALLOWED
                infotyp = eInfoTyp.Fehler
                Text = "Das Laufwerk untersttzt diesen Vorgang nicht"
            Case NERO_BURN_ERROR.NERO_BURN_INVALID_DRIVE
                infotyp = eInfoTyp.Fehler
                Text = "Das Laufwerk ist ungltig"
            Case NERO_BURN_ERROR.NERO_BURN_UNKNOWN_CD_FORMAT
                infotyp = eInfoTyp.Fehler
                Text = "Der Datentrger ist fehlerhaft"
        End Select
        DurchzufhrenderVorgang = eVorgang.Keiner
        RaiseEvent CdGebrannt(Text, infotyp, StatusCode = NERO_BURN_ERROR.NERO_BURN_OK)
    End Sub

    'Textinformationen von der Nero-Api
    Private Sub AktuellesLaufwerk_OnAddLogLine(ByRef TextType As NEROLib.NERO_TEXT_TYPE, ByRef Text As String) Handles AktuellesLaufwerk.OnAddLogLine
        Dim infotyp As eInfoTyp
        Select Case TextType
            Case NERO_TEXT_TYPE.NERO_TEXT_EXCLAMATION
                infotyp = eInfoTyp.Fehler
            Case NERO_TEXT_TYPE.NERO_TEXT_QUESTION
                infotyp = eInfoTyp.Frage
            Case Else
                infotyp = eInfoTyp.Info
        End Select
        RaiseEvent NeueLogZeile(Text, infotyp)
    End Sub

    'Gibt Fortschrittsangaben als Text an Log-Liste
    Private Sub AktuellesLaufwerk_OnSetPhase(ByRef Text As String) Handles AktuellesLaufwerk.OnSetPhase
        RaiseEvent NeueLogZeile(Text, eInfoTyp.Info)
    End Sub

    'Nero-Api hat einen Fehler
    Private Sub Nero_OnMegaFatal() Handles Nero.OnMegaFatal
        RaiseEvent SchwererFehler()
    End Sub

    ' Stellt sicher, dass auf den Datentrger gebrannt werden kann,  
    ' informiert, ob Cd schon teilweise beschrieben ist und fragt, ob
    ' sie trotzdem beschrieben werden soll. Lscht nach Abfrage CD RW
    Private Sub AktuellesLaufwerk_OnDoneCDInfo(ByVal pCDInfo As NEROLib.INeroCDInfo) Handles AktuellesLaufwerk.OnDoneCDInfo
        Dim Loslegen As Boolean = True 'Werden alle Prfungen bestanden, wird der Brennvorgang gestartet
        'Laufwerk bereit?:
        If AktuellesLaufwerk.DeviceReady = False Then
            Loslegen = False
            RaiseEvent CdGebrannt("Das Laufwerk ist nicht bereit", eInfoTyp.Fehler, False)
            RaiseEvent VorgangAktivnderung(False)
            Exit Sub
            'Muss Sub verlassen, da es bei nchster Abfrage zu Fehler kme
        End If
        If pCDInfo.IsWriteable = False Then
            RaiseEvent CdGebrannt("Das Laufwerk ist nicht bereit", eInfoTyp.Fehler, False)
            Loslegen = False
            RaiseEvent VorgangAktivnderung(False)
        End If

        If DurchzufhrenderVorgang = eVorgang.Brennen Then
            'Brenn-Spezifische Abfragen
            '---
            'Wenn die Cd Tracks enthlt, wird der Brennvorgang abgebrochen
            If pCDInfo.Tracks.Count > 0 Then
                If pCDInfo.MediaType = NERO_MEDIA_TYPE.NERO_MEDIA_CDRW Then
                    'Ist jedoch eine Cd RW eingelegt, wird dem Benutzer ermglicht, diese zu lschen
                    'und anschlieend automatisch zu beschreiben
                    Dim Antwort As MsgBoxResult
                    Const Text As String = "Die CD RW ist nich leer. Wollen Sie die Cd lschen und dann beschreiben? Andernfalls wird der Brennvorgang abgebrochen."
                    'Wenn automatisches Lschen ausgestellt ist, wird vorher abgefragt
                    If Settings.CDRWAutomatischLschen = False Then
                        Antwort = MsgBox(Text, MsgBoxStyle.Question Or MsgBoxStyle.YesNo)
                    Else
                        Antwort = MsgBoxResult.Yes
                    End If
                    RaiseEvent NeueLogZeile(Text, eInfoTyp.Frage)
                    If Antwort = MsgBoxResult.Yes Then
                        RaiseEvent NeueLogZeile("Antwort war ""Ja""", eInfoTyp.Info)
                        ErneutesBrennen = eErneutesBrennen.SollLschen
                        WarteKlasse.Warte(3000)
                    Else
                        RaiseEvent NeueLogZeile("Antwort war ""Nein""", eInfoTyp.Info)
                    End If
                Else
                    RaiseEvent NeueLogZeile("CD-R ist nicht leer", eInfoTyp.Fehler)
                End If
                Loslegen = False
            End If
            '---
            If Loslegen Then
                Brennen()
            End If
        Else 'Lschen:
            'Lsch-Spezifische Abfregen
            If pCDInfo.MediaType <> NERO_MEDIA_TYPE.NERO_MEDIA_CDRW Then
                Loslegen = False
            End If
            '---
            If Loslegen Then
                AktuellesLaufwerk.EraseCDRW(Settings.SchnellLschung)
            Else
                RaiseEvent CdGelscht(False, "Es knnen nur CD RW gelscht werden", eInfoTyp.Fehler)
                RaiseEvent VorgangAktivnderung(False)
            End If
        End If
    End Sub

    'Nero wartet auf eine Cd mit ausreichend Kapazitt
    'Wird (glaub ich) nur aufgerufen, wenn Cd zu klein, bzw Daten zu gro sind: Wenn keine Cd eingelegt ist,
    'wird dies schon ber CdInfo abgefragt
    Private Sub Nero_OnWaitCD(ByRef WaitCD As NEROLib.NERO_WAITCD_TYPE, ByRef WaitCDLocalizedText As String) Handles Nero.OnWaitCD
        'Abfrage: Sonst kommt Meldung immer zweimal
        Const Text As String = "Bitte einen Rohling mit ausreichend Kapazitt einlegen"
        RaiseEvent NeueLogZeile(Text, eInfoTyp.Kritisch)
    End Sub
#End Region


    'Abbrechen, StarteBrennen, LscheRW
#Region "Subs zum Aufrufen von auerhalb der Klasse"
    'Bricht Brennvorgang ab oder stellt sich aufs Abbrechen ein.
    'Wird whrend des Lschens, dass als Vorbereitung zum Schreiben dient, abgebrochen,
    'startet der Brennvorgang erst garnicht. Das Lschen kann jedoch nicht abgebrochen werden
    Friend Sub Abbrechen()
        Nero.Abort()
        SollAbbrechen = True
    End Sub

    'Ruft CdInfo auf, um festzustellen, ob die Cd beschreibbar ist, bzw ob der Benutzer brennen will, wenn ja, wird Brennvorgang gestartet
    Friend Sub StarteBrennen()
        ErneutesBrennen = eErneutesBrennen.Fertig
        DurchzufhrenderVorgang = eVorgang.Brennen
        SollAbbrechen = False
        If Settings.Verzeichnisse Is Nothing Then
            RaiseEvent NeueLogZeile("Es sind keine Verzeichnisse zum Brennen ausgewhlt, bitte Klicken Sie auf ""ndern...""", eInfoTyp.Kritisch)
            DurchzufhrenderVorgang = eVorgang.Keiner
            Exit Sub
        End If
        RaiseEvent VorgangAktivnderung(True)
        RaiseEvent NeueLogZeile("Starte Brennvorgang", eInfoTyp.Info)
        If AktuellesLaufwerkSetzen() = False Then RaiseEvent VorgangAktivnderung(False) : Exit Sub
        AktuellesLaufwerk.CDInfo(NERO_CDINFO_FLAGS.NERO_READ_ISRC)
    End Sub

    'Ruft OnCdInfo auf, das spter die RW lscht
    Friend Sub LscheRW()
        DurchzufhrenderVorgang = eVorgang.Lschen
        RaiseEvent VorgangAktivnderung(True)
        RaiseEvent NeueLogZeile("Lsche CD RW", eInfoTyp.Info)
        If AktuellesLaufwerkSetzen() = False Then RaiseEvent VorgangAktivnderung(False) : Exit Sub
        AktuellesLaufwerk.CDInfo(NERO_CDINFO_FLAGS.NERO_READ_ISRC)
    End Sub
#End Region


    'WarteKlasse_FertigGewartet, AktuellesLaufwerkSetzen, ErstelleDateisystem, Brennen
#Region "Subs zum Brennen"
    'Siehe Info zu clsWarten
    Private Sub WarteKlasse_FertigGewartet() Handles WarteKlasse.FertigGewartet
        If ErneutesBrennen = eErneutesBrennen.SollLschen Then ErneutesBrennen = eErneutesBrennen.IstAktiv : LscheRW()
        If ErneutesBrennen = eErneutesBrennen.SollBrennen Then
            If SollAbbrechen = False Then
                ErneutesBrennen = eErneutesBrennen.IstAktiv
                StarteBrennen()
            Else
                RaiseEvent NeueLogZeile("Brennvorgang vor Beginn abgebrochen", eInfoTyp.Kritisch)
                ErneutesBrennen = eErneutesBrennen.Fertig
                RaiseEvent VorgangAktivnderung(False)
            End If
        End If
    End Sub

    'Erstellt ein NeroDrive-Objekt anhand der unter Settings gespeicherten Einstellung
    'True: Wenns geklappt hat
    'False: Es wurde kein Laufwerk festgelegt, Brennvorgang muss abgebrochen werden
    Private Function AktuellesLaufwerkSetzen() As Boolean
        For Each Lw As NeroDrive In Nero.GetDrives(NERO_MEDIA_TYPE.NERO_MEDIA_CDRW)
            If Lw.DriveLetter = Settings.Laufwerk Then AktuellesLaufwerk = Lw
        Next
        If AktuellesLaufwerk Is Nothing Then
            RaiseEvent NeueLogZeile("Es wurde kein Laufwerk ausgewhlt", eInfoTyp.Fehler)
            Return False
        Else
            Return True
        End If
    End Function

    'Fgt dem IsoImage rekursiv alle im Ordner angegebene Dateien hinzu
    'Zielordner: Das NeroFolder-Objekt, was dem Iso-Track hinzugefgt wird
    'Quellordner: Der Pfad des Ordners auf der Festplatte
    Private Sub ErstelleDateisystem(ByVal ZielOrdner As NeroFolder, ByVal QuellOrdner As String)
        On Error Resume Next 'Ntig fr etwaige Zugriffsverletzungen
        'Schleifenvariablen:
        Dim NeueDatei As NeroFile
        Dim NeuerOrdner As NeroFolder

        'Alle Dateien im Ordner werden durchgegangen und in die Nero-Ordnerstruktur bernommen:
        For Each QuellDatei As String In IO.Directory.GetFiles(QuellOrdner)
            NeueDatei = New NeroFile
            NeueDatei.EntryTime = New IO.FileInfo(QuellDatei).CreationTime
            NeueDatei.Name = New IO.FileInfo(QuellDatei).Name
            NeueDatei.SourceFilePath = QuellDatei
            ZielOrdner.Files.Add(NeueDatei)
        Next
        'Das Gleiche passiert mit Unterordnern, Prozedur ruft sich fr jeden Unterordner selbst auf.
        For Each UnterOrdner As String In IO.Directory.GetDirectories(QuellOrdner)
            If Not UnterOrdner Is Nothing Then  'Kommt bei Zugriffsfehlern vor
                NeuerOrdner = New NeroFolder
                NeuerOrdner.Name = New IO.DirectoryInfo(UnterOrdner).Name
                ZielOrdner.Folders.Add(NeuerOrdner)
                ErstelleDateisystem(NeuerOrdner, UnterOrdner) 'Rekursion
            End If
        Next
    End Sub

    'Erstellt Ordnerstruktur mit Hilfe von Sub "ErstelleDateisystem" und sagt der Api, dass sie brennen soll
    Private Sub Brennen()
        Dim Track As New NeroISOTrack
        Dim ZielOrdner As New NeroFolder
        Dim UnterOrdner As NeroFolder
        Dim Flags As NEROLib.NERO_BURN_FLAGS
        Dim GeschwindigkeitVergbar As Boolean = False
        Dim WirklicheGeschwindigkeit As Integer  'Im Gegensatz zu der in Settings eingestellten Geschwindigkeit ist diese mit dem eingelegten Medium wirklich verfgbar
        Dim nchsteGeschwindigkeitDifferenz As Integer = Integer.MaxValue 'Ist eine Geschwindigkeit ausgewhlt, die nicht mglich ist, sondern zwischen zwei mglichen Geschwindigkeiten liegt, so wird beim Lesen der mglichen Geschwindigkeiten die G. festgehalten, die der eingestellten am Nchsten ist
        Dim indexwirklicheGeschwindigkeit As Integer 'Index dieser G.

        Track.RootFolder = ZielOrdner
        'Jeder in Settings angegebener Ordner wird durchgegangen und zum Verzeichnisbaum der Cd hinzugefgt
        'Hierbei Ist "Unterodner" das entsprechende Pedant zu dem in Settings angegebenen Hauptordner...
        'Es knnen auch durchaus mehrere gleichnamige Ordner ins Hauptverzeichnis  gebrannt werden; Nero benennt sie automatisch um (Setzt 2, 3, 4, n dahinter)
        For Each Quellordner As String In Settings.Verzeichnisse
            UnterOrdner = New NeroFolder

            UnterOrdner.Name = New IO.DirectoryInfo(Quellordner).Name

            ZielOrdner.Folders.Add(UnterOrdner)
            RaiseEvent NeueLogZeile("Sammele Dateien fr " & Quellordner, eInfoTyp.Info)
            ErstelleDateisystem(UnterOrdner, Quellordner)
            Application.DoEvents()
        Next Quellordner

        'Geschwindigkeiten:
        'Es wird die Geschwindigkeit gesucht, die der eingestellten G. am nchsten kommt.
        For i As Integer = 0 To AktuellesLaufwerk.WriteSpeeds.Count - 1
            'Differenz zw. eingestellter und mglicher Geschwindigkeit soll mglichst klein sein
            If Math.Abs(AktuellesLaufwerk.WriteSpeeds.Item(i) - Settings.Geschwindigkeit) < nchsteGeschwindigkeitDifferenz Then
                indexwirklicheGeschwindigkeit = i
                nchsteGeschwindigkeitDifferenz = Math.Abs(AktuellesLaufwerk.WriteSpeeds.Item(i) - Settings.Geschwindigkeit)
            End If
            If AktuellesLaufwerk.WriteSpeeds.Item(i) = Settings.Geschwindigkeit Then
                indexwirklicheGeschwindigkeit = i
                Exit For
            End If
        Next

        'Eingemachtes:
        RaiseEvent VorgangAktivnderung(True)
        Track.BurnOptions = NERO_BURN_OPTIONS.NERO_BURN_OPTION_CREATE_ISO_FS Or NERO_BURN_OPTIONS.NERO_BURN_OPTION_USE_JOLIET
        Track.Name = Settings.CdName & CType(IIf(Settings.DatumHinzufgen, Now.ToString(" dd.MM.yy"), ""), String)
        Flags = NERO_BURN_FLAGS.NERO_BURN_FLAG_WRITE
        If Settings.BufferUnderrunSchutz Then Flags = Flags Or NERO_BURN_FLAGS.NERO_BURN_FLAG_BUF_UNDERRUN_PROT

        AktuellesLaufwerk.BurnIsoAudioCD("", "", True, Track, Nothing, Nothing, NERO_BURN_FLAGS.NERO_BURN_FLAG_WRITE, AktuellesLaufwerk.WriteSpeeds.Item(indexwirklicheGeschwindigkeit), NERO_MEDIA_TYPE.NERO_MEDIA_CDRW)
    End Sub
#End Region

End Class
